import 'package:puissance4/utils/tools.dart';

class DefaultGameSettings {
  // available game parameters codes
  static const String parameterCodeGameMode = 'gameMode';
  static const String parameterCodeSize = 'size';
  static const List<String> availableParameters = [
    parameterCodeGameMode,
    parameterCodeSize,
  ];

  // game mode: available values
  static const String gameModeHumanVsHuman = 'human-vs-human';
  static const String gameModeHumanVsRobot = 'human-vs-robot';
  static const String gameModeRobotVsHuman = 'robot-vs-human';
  static const String gameModeRobotVsRobot = 'robot-vs-robot';
  static const List<String> allowedGameModeValues = [
    gameModeHumanVsHuman,
    gameModeHumanVsRobot,
    gameModeRobotVsHuman,
    gameModeRobotVsRobot,
  ];
  // game mode: default value
  static const String defaultGameModeValue = gameModeHumanVsHuman;

  // size: available values
  static const String sizeValueMedium = '7x6';
  static const List<String> allowedSizeValues = [
    sizeValueMedium,
  ];
  // size: default value
  static const String defaultSizeValue = sizeValueMedium;

  // available values from parameter code
  static List<String> getAvailableValues(String parameterCode) {
    switch (parameterCode) {
      case parameterCodeGameMode:
        return DefaultGameSettings.allowedGameModeValues;
      case parameterCodeSize:
        return DefaultGameSettings.allowedSizeValues;
    }

    printlog('Did not find any available value for game parameter "$parameterCode".');
    return [];
  }
}
