import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import 'package:puissance4/cubit/game_cubit.dart';
import 'package:puissance4/models/game/game.dart';
import 'package:puissance4/ui/widgets/game/game_board.dart';
import 'package:puissance4/ui/widgets/game/game_bottom.dart';
import 'package:puissance4/ui/widgets/game/game_end.dart';

class GameLayout extends StatelessWidget {
  const GameLayout({super.key});

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<GameCubit, GameState>(
      builder: (BuildContext context, GameState gameState) {
        final Game currentGame = gameState.currentGame;

        return Container(
          alignment: AlignmentDirectional.topCenter,
          padding: const EdgeInsets.all(4),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: [
              const SizedBox(height: 48),
              const GameBoardWidget(),
              const SizedBox(height: 16),
              const GameBottomWidget(),
              const Expanded(child: SizedBox.shrink()),
              currentGame.isFinished ? const GameEndWidget() : const SizedBox.shrink(),
            ],
          ),
        );
      },
    );
  }
}
