import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import 'package:puissance4/cubit/game_cubit.dart';
import 'package:puissance4/models/game/game.dart';
import 'package:puissance4/ui/helpers/styled_button.dart';

class GameBottomWidget extends StatelessWidget {
  const GameBottomWidget({super.key});

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<GameCubit, GameState>(
      builder: (BuildContext context, GameState gameState) {
        final Game currentGame = gameState.currentGame;

        final Color color = currentGame.currentPlayer == 0
            ? Colors.grey
            : (currentGame.currentPlayer == 1 ? Colors.yellow : Colors.red);

        return StyledButton(
          color: color,
          onPressed: () {},
          child: SizedBox.shrink(),
        );
      },
    );
  }
}
